import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.migration.entity.ExampleTable;
import com.migration.entity.ExampleTableHome;
import com.migration.session.EmpolyeeInfo;
import com.migration.session.EmpolyeeInfoLocal;

public class EJBTestCase {

	public void sessionBeanTestCase() {
		Hashtable<String, String> envs = new Hashtable<String, String>();
		envs.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
		InitialContext context;
		try {
			context = new InitialContext(envs);
			String lookupName = this.getSessionBeanLookupName();
			System.out.println("JNDI : " + lookupName);
			EmpolyeeInfoLocal remote = (EmpolyeeInfoLocal) context.lookup(lookupName);
			System.out.println(remote.getEmpFullName("Hello Buddy"));
		} catch (NamingException e) {
			e.printStackTrace();
			return;
		} catch (RemoteException e) {
			e.printStackTrace();
			return;
		}
		System.out.println("Session bean invocation is completed...");
	}
	
	
	public void entityBeanTestCase() {
		Hashtable<String, String> envs = new Hashtable<String, String>();
		envs.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
		InitialContext context;
		try {
			context = new InitialContext(envs);
			String lookupName = this.getEntityBeanLookupName();
			System.out.println("JNDI : " + lookupName);
			ExampleTable remote = (ExampleTable) context.lookup(lookupName);
			
			
			ExampleTableHome home = (ExampleTableHome) remote.getEJBHome();
//			ExampleTable table = null;
//			try {
//				table = home.create("Test", new Integer(1));
//			} catch (Exception e) {
//				e.printStackTrace();
//			}
//			System.out.println(table.getEmpname());
			
		} catch (NamingException e) {
			e.printStackTrace();
			return;
		} catch (RemoteException e) {
			e.printStackTrace();
			return;
		} catch(Exception e){
			e.printStackTrace();
			return;
		}
//		System.out.println("Row is created...");
	}

	private String getSessionBeanLookupName() {
		String appName = "";
		String moduleName = "MigrationEJB";
		String distinctName = "";
		String beanName = EmpolyeeInfo.class.getSimpleName();
		final String interfaceName = EmpolyeeInfoLocal.class.getName();
		String name = "ejb:" + appName + "/" + moduleName + "/" + distinctName + "/" + beanName + "!" + interfaceName;
		return name;
	}

	private String getEntityBeanLookupName() {
		String appName = "";
		String moduleName = "MigrationEJB";
		String distinctName = "";
		String beanName = ExampleTable.class.getSimpleName();
		final String interfaceName = ExampleTable.class.getName();
		String name = "ejb:" + appName + "/" + moduleName + "/" + distinctName + "/" + beanName + "!" + interfaceName;
		return name;
	}
	
	public static void main(String[] args) {
		new EJBTestCase().sessionBeanTestCase();
		
		new EJBTestCase().entityBeanTestCase();
		
	}

}
